/* ==========================================================================
  BUTTONS
===========================================================================*/
.btn,
.btn[type="button"] {

  //position
  position: relative;
  z-index: z(button);

  //box model
  display: inline-flex;
  align-items: center;
  justify-content: center;
  padding: btn(padding);
  min-width: btn(min-width);
  max-width: 100%;
  height: btn(height);

  //font
  font-size: btn(font-size);
  line-height: btn(line-height);
  font-weight: btn(font-weight);
  text-align: center;
  text-decoration: none;
  text-transform: uppercase;

  // other
  overflow: hidden;
  border-width:  btn(border-width);
  border-style: solid;
  border-radius: btn(border-radius);
  cursor: pointer;
  transition: all .3s ease;

  touch-action: manipulation;
  user-select: none;
  -webkit-appearance: inherit;

  &:focus {
    outline: none;
  }
  &:hover {
    cursor: pointer;
  }

  @include mq('laptop', 'max') {
    font-size: 14px;
  }

  @include mq('phone', 'max') {
    min-width: 200px;
  }

  &.btn_full {
    width: 100%;
    min-width: 0;
  }

  &.btn_small {
    padding: 0 16px;
    min-width: 160px;
    height: 35px;
    font-size: 13px;
  }

  .icon {
    width: 8px;
    height: 13px;
    margin-left: 7px;
  }
}

.btn__text {
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

/* disabled styles */
.btn.disabled,
.btn[disabled],
fieldset[disabled] .btn {
  cursor: not-allowed;
  pointer-events: none;
  opacity: .25;
  filter: alpha(opacity=25);
  -webkit-box-shadow: none;
  box-shadow: none;
}

button[type="button"] {
  cursor: pointer;
}

/* DEFAULT */

.btn_default {
  color: $btn-default-color;
  background-color: $btn-default-background-color;
  border-color: $btn-default-border-color;

  &:hover {
    color: $btn-default-color-hover;
    background-color: $btn-default-background-color-hover;
    border-color: $btn-default-border-color-hover;
  }

  &:active {
    color: $btn-default-color-active;
    background-color: $btn-default-background-color-active;
    border-color: $btn-default-border-color-active;
  }
}

/* PRIMARY */

.btn_primary {
  color: $btn-primary-color;
  background-color: $btn-primary-background-color;
  border-color: $btn-primary-border-color;

  &:hover {
    color: $btn-primary-color-hover;
    background-color: $btn-primary-background-color-hover;
    border-color: $btn-primary-border-color-hover;
  }

  &:active {
    color: $btn-primary-color-active;
    background-color: $btn-primary-background-color-active;
    border-color: $btn-primary-border-color-active;
  }
}

/* SECONDARY */

.btn_secondary {
  color: $btn-secondary-color;
  background-color: $btn-secondary-background-color;
  border-color: $btn-secondary-border-color;

  &:hover {
    color: $btn-secondary-color-hover;
    background-color: $btn-secondary-background-color-hover;
    border-color: $btn-secondary-border-color-hover;
  }

  &:active {
    color: $btn-secondary-color-active;
    background-color: $btn-secondary-background-color-active;
    border-color: $btn-secondary-border-color-active;
  }
}

/* end buttons*/
